<!DOCTYPE html>

<html lang="en">

<head>

    <meta charset="UTF-8">

    <meta http-equiv="X-UA-Compatible" content="IE=edge">

    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <title>Tugas Component</title>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>

</head>

<body>

    <div id="app">

        <div class="formInput">

            <input type="text" v-model="formUser">

            <button v-if="!editButton" @click="addUser">

                Add</button>

            <button v-if="editButton" @click="updateUser">

                Update</button>

        </div>
        <div>
            <ul>
                <component-user
                    v-for="(user, index) in reverseUsers"
                    :key="index"
                    :user="user"
                    :index="index"
                    @emitedituser="editUser($event)"
                    @emitdeleteuser="deleteUser($event)"
                ></component-user>
            </ul>
        </div>
 


    </div>

 

    <script>

        let ComponentUserList = {
            template : `
                    <li> {{ index }}:{{ user.name }} || 
                        <button @click="$emit('emitedituser',index)">Edit</button>
                        <button @click="$emit('emitdeleteuser',index)">Delete</button>
                    </li>`,
            props : ['user', 'index']
        }

        let vm = new Vue({

            el: '#app',
            components : {
                    'component-user' : ComponentUserList
            },

            data: {

                users: [

                    { name: 'Muhammad Iqbal Mubarok' },

                    { name: 'Ruby Purwanti' },

                    { name: 'Faqih Muhammad' },

                ],

                formUser: '',

                editButton: false,

                idSelected: null

            },

            computed: {

                reverseUsers: {

                    get: function () {

                        return this.users.slice().reverse()

                    },

                    set: function (value) {

                        this.users = value.slice().reverse()

                    }

                }

            },

            methods: {

                addUser: function () {

                    this.users.push({ name: this.formUser })

                    this.formUser = ''

                },

                editUser: function (id) {

                    this.formUser = this.reverseUsers[id].name

                    this.editButton = true,

                    this.idSelected = id

                },

                updateUser: function () {

                    this.reverseUsers[this.idSelected].name = this.formUser

                    this.formUser = ''

                    this.editButton = false

                },

                deleteUser: function (id) {

                    let confirmation = confirm("Anda yakin ?")

 

                    if (confirmation) {

                        this.reverseUsers = this.reverseUsers.filter(function (item, index) {

                            return index != id

                        })

                    }

                }

            }

        })

    </script>

</body>

</html>